using System;
class Program
{
    static void Main(string[] args)
    {
        int N = int.Parse(Console.ReadLine());
        int[,] a = new int[N, N];
        for(int i = 0; i < N; i++)
        {
            string[] c = Console.ReadLine().Split(' ');
            a[int.Parse(c[0]) - 1, int.Parse(c[1]) - 1] = 1;
        }
        int resenje = 0;
        for (int i=0; i < N; i++)
        {
            int br = 0;
            for (int j=0; j < N; j++)
            {
                if(a[i,j] == 1)
                {
                    br++;
                }
            }
            if (br > 1)
            {
                resenje = N - 1;
            }
            br = 0;
            for (int j = 0; j < N; j++)
            {
                if (a[j, i] == 1)
                {
                    br++;
                }
            }
            if (br > 1)
            {
                resenje = N - 1;
            }
        }
        Console.WriteLine(resenje);
    }
}